/***************************************************************************
                          centralwin.h  -  description
                             -------------------
    begin                : Mit Mr 5 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CENTRALWIN_H
#define CENTRALWIN_H

#include <qwidget.h>
#include <qtabwidget.h>
#include <qmap.h>
#include <qpopupmenu.h>
#include <kiconloader.h>
#include "cwinerrortab.h"
#include "cwinstarttab.h"
#include "cwinresulttab.h"
#include "cwinselallrestab.h"
#include "cwinsqlouttab.h"
#include "cwintabletab.h"
#include "cwinquerylisttab.h"
#include "cwininfotab.h"
#include "ksqlshelldoc.h"

/**
  *@author Olaf Gawenda
  */
class  CwinQueryListTab;
class CentralWin : public QTabWidget {
   Q_OBJECT
public: 
	CentralWin(QWidget *parent=0, const char *name=0);
	~CentralWin();
    void showResultTab(KSqlShellDoc *doc, SqlClient *sqlCl);
    void showTableTab(KSqlShellDoc *doc, SqlTable & sqlTable);
    void showInfoTab(KSqlShellDoc * doc, const QString & conStr);
    void showQueryList(KSqlShellDoc *doc);
    QMap<QString, CwinTab*> labelMap;
    QString currentLabel;
    QMap<QString, CwinTab*>::iterator labelMapIt;
    bool queryList;
    CwinQueryListTab * qListTab;
private:
    void showStartTab();
    QPopupMenu *tabMenu;
    KIconLoader iLoader;
    QString makeLabel(const QString & preLabel);
    
protected:
    bool eventFilter(QObject *o, QEvent *e);
private slots:
    void slotAction(int id);  
};

#endif
