/***************************************************************************
                          cwinerrortab.cpp  -  description
                             -------------------
    begin                : Don Mai 8 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cwinerrortab.h"
#include <qdatetime.h>
#include <klocale.h>

CwinErrorTab::CwinErrorTab(KSqlShellDoc *document, SqlClient *sqlClient, Result * result, const QString & label, QWidget *parent, const char *name) : CwinSqlOutTab(document, sqlClient, result, label, parent,name) {
  setLabelTextHeight(40);
  QString header = sqlCl->queryInput.getConStr() + "  db: '" + sqlCl->queryInput.getDbStr() + "'";
  QString h = sqlCl->queryInput.getConStr() + "  <b>" + i18n("DATABASE") + ":</b> ";
  h += sqlCl->queryInput.getDbStr() + "  <b>" + i18n("TABLE") + ":</b> " + sqlCl->queryInput.getTabStr();
  h += "  <b>" + i18n("TIME") + ":</b>  " + QTime::currentTime().toString() + "<b>  " + i18n("QUERY") + ":</b><br>";
  h += "<pre>" + res->getStmt() + "</pre>";
  labelText->setText(h);
  
  QString error = "<br><font color=\"red\"><b>" + i18n("ERROR") + ":</b>  " + res->getError() + "</font>";  
  labelText->append(error);

  delete page; 
}
CwinErrorTab::~CwinErrorTab(){
}
