/***************************************************************************
                          querylisttab.h  -  description
                             -------------------
    begin                : Fre Jun 20 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CWINQUERYLISTTAB_H
#define CWINQUERYLISTTAB_H

#include <qwidget.h>
#include <qvgroupbox.h>
#include <qlineedit.h>
#include <qlabel.h>
#include <qpopupmenu.h>
#include "ksqlshelldoc.h"
#include "centralwin.h"
#include "navilist.h"
#include "cwintab.h"
/**
  *@author Olaf Gawenda
  */

class CwinQueryListTab : public CwinTab  {
   Q_OBJECT
public: 
	CwinQueryListTab(KSqlShellDoc * document, const QString & label, QWidget *parent=0, const char *name=0);
	~CwinQueryListTab();
    
public slots:
  void slotSyncList();
  void slotDelText();
private:
  void delTab();
  void sync(QStringList & list, QListViewItem * item, bool renameEnabled = false);
  void updateQuery(QListViewItem *item, bool name);
  void newItem();
  void deleteItem();
  QString getNewName(QListViewItem *item);
  KSqlShellDoc *doc;
  QString currentItemStr;
  CentralWin *cwin;
  NaviList *queryList;
  QTextEdit * queryText, *queryDiscr;
  QVGroupBox *vGroupBox, *vGroupBox1, *vGroupBox2;
  QHBoxLayout * hLayout2;
  QVBoxLayout * vLayout2;
  QPushButton *saveButton;
  QPushButton *newConButton;
  QPopupMenu *conMenu;
  QPopupMenu *dbMenu;
  QPopupMenu *queryMenu;
  QListViewItem *cItem;
  QPixmap saveQueryPix, newConPix;
  bool cut;
  QueryInput cQInput;
 
private slots:
  void slotSaveList();
  void slotNewCon();
  void slotRename(QListViewItem *item, int col, const QString & text);
  void slotSelect(QListViewItem *item);
  void slotListPopupMenu(QListViewItem* listItem, const QPoint &p, int con);
  void slotConMenuActivated(int id);
  void slotDbMenuActivated(int id);
  void slotQueryMenuActivated(int id);
  
};

#endif
