/***************************************************************************
                          resulttab.h  -  description
                             -------------------
    begin                : Die Apr 29 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef RESULTTAB_H
#define RESULTTAB_H

#include <qwidget.h>
#include "table.h"
#include <qstring.h>
#include <kmessagebox.h>
#include "cwinsqlouttab.h"
#include "ksqlshelldoc.h"

/**
  *@author Olaf Gawenda
  */

class CwinResultTab : public CwinSqlOutTab {
   Q_OBJECT
public: 
	CwinResultTab(KSqlShellDoc *document, SqlClient *sqlClient, Result *result, const QString & label, QWidget *parent, const char *name=0);
	~CwinResultTab();
    void showResult();
    void refresh(SqlClient *sqlClient);
protected:

    QPushButton * transposeButton;
    QPushButton *updButton;
    Table *table;
    bool transpose;
    bool transposable;
    virtual void transposeResult(){};
    virtual void refr(){};
    QPixmap transResPix, recordPix, transpRecordPix, updPix;
    QString makeHeaderText();
protected slots:
    void slotTransposeResult();
    virtual void slotUpdate();
};

#endif
