/***************************************************************************
                          cwinselallrestab.h  -  description
                             -------------------
    begin                : Don Mai 8 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CWINSELALLRESTAB_H
#define CWINSELALLRESTAB_H

#include <qwidget.h>
#include <cwinresulttab.h>
#include <qpopupmenu.h>
#include <qrect.h>
#include <qstringlist.h>
#include "selectwidget.h"
#include "sqltable.h"

/**
  *@author Olaf Gawenda
  */

class CwinSelAllResTab : public CwinResultTab  {
   Q_OBJECT
public: 
	CwinSelAllResTab(KSqlShellDoc *document, SqlClient *sqlClient, Result *result, const QString & label, QWidget *parent, const char *name=0);
	~CwinSelAllResTab();
    
protected:
    SelectWidget *selWidget;
    QPopupMenu *menu;
    QPixmap undoPix;
    QPushButton *undoButton;
    void transposeResult();
    void getRow(bool edit);
    void refr();
    QString makeWhere();
    QString makeHeaderText();
    int currentPos;
    int minRow, maxRow;
    QStringList oldRow;
    QString menuAction;
    SqlTable sqlTable;
protected slots:
    void slotNextRows(int offset, int count, const QString & orderBy);
    void slotMenu(int pos);
    void slotAction(int id);
    void slotUpdate();
    void slotUndo();
};

#endif
