/***************************************************************************
                          cwinsqlouttab.cpp  -  description
                             -------------------
    begin                : Don Mai 8 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <kmessagebox.h>
#include <klocale.h>
#include "cwinsqlouttab.h"
#include "editquerydlg.h"

CwinSqlOutTab::CwinSqlOutTab(KSqlShellDoc *document, SqlClient *sqlClient, Result * result, const QString & label, QWidget *parent, const char *name) : CwinTab(label, parent,name) {
 
  sqlCl = sqlClient;
  res = result;
  doc = document;
  tabQueryInput = sqlCl->queryInput;
  refreshQuery = "";
  
  reloadPix =  iLoader.loadIcon("reload", KIcon::MainToolbar);
  editPix = iLoader.loadIcon("edit", KIcon::MainToolbar);

  editButton = new QPushButton(QIconSet(editPix), "", bGrid);
  connect(editButton, SIGNAL(clicked()), this, SLOT(slotEdit()));
  QToolTip::add(editButton, i18n("edit and run"));
  
  if(tabQueryInput.isInput()) {
    reloadButton = new QPushButton(QIconSet(reloadPix),"",bGrid);
    connect(reloadButton, SIGNAL(clicked()), this, SLOT(slotReload()));
    QToolTip::add(reloadButton, i18n("new input"));
  }
    
}
CwinSqlOutTab::~CwinSqlOutTab(){
}
void CwinSqlOutTab::delTab(){
  sqlCl->resultList.remove(res);
  
  QString conStr = sqlCl->queryInput.getConStr();
  
  if(sqlCl->resultList.isEmpty()){
    if(doc->clQueueMap.contains(conStr))
      doc->clQueueMap[conStr]->freeCl(sqlCl);
    else
      delete sqlCl;
  }
}
void CwinSqlOutTab::slotReload(){
  QueryInput qi = tabQueryInput;
  qi.setCheckInput(true);
  qi.setRefresh(false);
  if(!doc->sendQuery(qi))
    KMessageBox::error(this, doc->getError());  
}
void CwinSqlOutTab::slotEdit(){
  tabQueryInput.setResultLabel(tabLabel);
  EditQueryDlg dlg(doc, tabQueryInput, res, refreshQuery, this, i18n("edit query"));
  dlg.exec();
}