/***************************************************************************
                          cwintab.h  -  description
                             -------------------
    begin                : Mit Apr 30 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CWINTAB_H
#define CWINTAB_H

#include <qwidget.h>
#include <qlayout.h>
#include <qpushbutton.h>
#include <qtextedit.h>
#include <qsplitter.h>
#include <qvbox.h>
#include <qpixmap.h>
#include <qgrid.h>
#include <qtooltip.h>
#include <kiconloader.h>
/**
  *@author Olaf Gawenda
  */

class CentralWin;

class CwinTab : public QWidget  {
   Q_OBJECT
public:
	CwinTab(const QString & label, QWidget *parent, const char *name=0);
	~CwinTab();
    bool isPlug(){ return plug; };
    void setLabel(const QString & label) {tabLabel = label; };

public slots:
    void slotPlugTab();
    void slotDelTab();
private:
     void closeEvent(QCloseEvent *ce);
protected:
    virtual QString makeHeaderText() {return QString("");};
    virtual void delTab() = 0;
    void setLabelTextHeight(int height);
    CentralWin *tabBar;
    QString tabLabel;
    QTextEdit *labelText;
    QPushButton *delButton;
    QPushButton *plugButton;
    bool plug;

    QGridLayout *mLayout; 
    QSplitter *splitter;
    QWidget *page, *headerPage;
    QVBoxLayout *layout, *vHeaderLayout;
    QHBoxLayout *hLayout, *hHeaderLayout;
    KIconLoader iLoader;
    QPixmap delTabPix, plugTabPix, unplugTabPix;
    QGrid * bGrid;

    
};

#endif
