/***************************************************************************
                          editquerydlg.cpp  -  description
                             -------------------
    begin                : Die Jul 29 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <klocale.h>
#include <kmessagebox.h>
#include "editquerydlg.h"

EditQueryDlg::EditQueryDlg(KSqlShellDoc *document, QueryInput qi, Result * result, const QString & defQuery, QWidget *parent, const char *name ) : KDialogBase(parent,name, true, name, Ok | Cancel, Ok, true) {
  setButtonOKText(i18n("Run"));
  doc = document;
  oldInput = qi;
  page = new QWidget(this);
  setMainWidget(page);
  layout = new QVBoxLayout(page, 0, spacingHint());

  
  QString header = qi.getConStr() + " ";
  header += i18n("database") + ": '" + qi.getDbStr();
  
  if(!qi.getTabStr().isEmpty())
    header +=  "' " + i18n("table") + ": '" + qi.getTabStr() + "'";
  
  groupBox = new QVGroupBox(header, page);
  
  edit = new QTextEdit(groupBox);
  edit->setMinimumHeight(300);
  edit->setMinimumWidth(600);
  
  layout->addWidget(groupBox);

  if(defQuery.isEmpty())
    edit->setText(result->getStmt());
  else
    edit->setText(defQuery);

}
EditQueryDlg::~EditQueryDlg(){
}

void EditQueryDlg::slotOk(){
  QueryInput qi;
  qi.setConStr(oldInput.getConStr());
  qi.setDbStr(oldInput.getDbStr());
  qi.setType(QueryInput::Free);
  qi.setQuery(edit->text());

  if(!doc->sendQuery(qi))
    KMessageBox::error(this, doc->getError());
  else
    delayedDestruct();
}