/***************************************************************************
                          ksqlshellview.cpp  -  description
                             -------------------
    begin                : Mit Feb 26 16:50:35 CET 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// include files for Qt
#include <qprinter.h>
#include <qpainter.h>
#include <qvaluelist.h>

#include <klocale.h>
  
// application specific includes
#include "ksqlshellview.h"
#include "ksqlshelldoc.h"
#include "ksqlshell.h"
#include "ksqlshellsizes.h"


KSqlShellView::KSqlShellView(QWidget *parent, const char *name) : QWidget(parent, name)
{

  // main widget size
  setBaseSize(KSQLSHELL_WIDTH, KSQLSHELL_HEIGHT);
  
  mlayout = new QGridLayout(this);
  
  msplitter = new QSplitter(this);

  // navigation 

  naviList = new NaviList(msplitter);
  
  ssplitter = new QSplitter(Vertical,msplitter);

  // output list
  cwin = new CentralWin(ssplitter);
  
  // shell
  shell = new Shell(getDocument(), ssplitter);

  // splittersizes
  QValueList<int> msplitter_size = msplitter->sizes();            // init ?
  QValueList<int> ssplitter_size = ssplitter->sizes();             // init ?
  msplitter_size[0] = MSPLITTER_L;
  msplitter_size[1] = MSPLITTER_R;
  ssplitter_size[0] = SSPLITTER_T;
  ssplitter_size[1] = SSPLITTER_B;
  msplitter->setSizes(msplitter_size);
  ssplitter->setSizes(ssplitter_size);
  
  mlayout->addWidget(msplitter,0,0);

  connect(naviList, SIGNAL(signalDbChanged(const QString &, const QString &)), shell, SLOT(slotChangeDb(const QString &, const QString &)));

}

KSqlShellView::~KSqlShellView()
{
}

KSqlShellDoc *KSqlShellView::getDocument() const
{
  KSqlShellApp *theApp=(KSqlShellApp *) parentWidget();

  return theApp->getDocument();
}

void KSqlShellView::print(QPrinter *pPrinter)
{
  QPainter printpainter;
  printpainter.begin(pPrinter);
	
  // TODO: add your printing code here

  printpainter.end();
}
             
