/***************************************************************************
                          ksqlshellview.h  -  description
                             -------------------
    begin                : Mit Feb 26 16:50:35 CET 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KSQLSHELLVIEW_H
#define KSQLSHELLVIEW_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

// include files for Qt
#include <qwidget.h>
#include <qsplitter.h>
#include <qvaluelist.h>
#include <qlayout.h>
#include <qmap.h>
#include "sqlclient.h"
#include "navilist.h"
#include "shell.h"
#include "centralwin.h"


class KSqlShellDoc;


/** The KSqlShellView class provides the view widget for the KSqlShellApp instance.	
 * The View instance inherits QWidget as a base class and represents the view object of a KTMainWindow. As KSqlShellView is part of the
 * docuement-view model, it needs a reference to the document object connected with it by the KSqlShellApp class to manipulate and display
 * the document structure provided by the KSqlShellDoc class.
 * 	
 * @author Source Framework Automatically Generated by KDevelop, (c) The KDevelop Team.
 * @version KDevelop version 0.4 code generation
 */
class KSqlShellView : public QWidget
{
  Q_OBJECT
  public:
    /** Constructor for the main view */
    KSqlShellView(QWidget *parent = 0, const char *name=0);
    /** Destructor for the main view */
    ~KSqlShellView();

    /** returns a pointer to the document connected to the view instance. Mind that this method requires a KSqlShellApp instance as a parent
     * widget to get to the window document pointer by calling the KSqlShellApp::getDocument() method.
     *
     * @see KSqlShellApp#getDocument
     */
    KSqlShellDoc *getDocument() const;

    /** contains the implementation for printing functionality */
    void print(QPrinter *pPrinter);

    NaviList *naviList;
    CentralWin * cwin;
    Shell * shell;
  protected:
    
    

  private:
	 QGridLayout * mlayout;
    QSplitter * msplitter;
    QSplitter * ssplitter;
           
    
     
};

#endif // KSQLSHELLVIEW_H
