/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Mit Feb 26 16:50:35 CET 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kcmdlineargs.h>
#include <kaboutdata.h>
#include <klocale.h>

#include "ksqlshell.h"

static const char *description =
	I18N_NOOP("KSqlShell");
// INSERT A DESCRIPTION FOR YOUR APPLICATION HERE
	
	
static KCmdLineOptions options[] =
{
  { "+[File]", I18N_NOOP("file to open"), 0 },
  { 0, 0, 0 }
  // INSERT YOUR COMMANDLINE OPTIONS HERE
};

int main(int argc, char *argv[])
{
	KAboutData aboutData( "ksqlshell", I18N_NOOP("KSqlShell"),
		VERSION, description, KAboutData::License_GPL,
		"(c) 2003, Olaf Gawenda", 0, 0, "o.gawenda@gmx.de");
	aboutData.addAuthor("Olaf Gawenda",0, "o.gawenda@gmx.de");
	KCmdLineArgs::init( argc, argv, &aboutData );
	KCmdLineArgs::addCmdLineOptions( options ); // Add our own options.

  KApplication app;
 
  if (app.isRestored())
  {
    RESTORE(KSqlShellApp);
  }
  else 
  {
    KSqlShellApp *ksqlshell = new KSqlShellApp();
    
    ksqlshell->show();

    KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
		
		if (args->count())
		{
        ksqlshell->openDocumentFile(args->arg(0));
		}
		else
		{
		  ksqlshell->openDocumentFile();
		}
		args->clear();
  }

  return app.exec();
}  
