/***************************************************************************
                          mytabdlg.cpp  -  description
                             -------------------
    begin                : Mon Apr 7 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <klocale.h>
#include <qsize.h>
#include "mytabdlg.h"

MyTabDlg::MyTabDlg(QWidget *parent, const QString & caption, KSqlShellDoc * document, const QString & conStr, const QString & database)
                          : TabDlg(parent, caption, document, conStr, database)
{
  table->setNumCols(11);
  table->horizontalHeader()->setLabel(8, i18n("Index"));
  table->horizontalHeader()->setLabel(9, i18n("Values"));
  table->horizontalHeader()->setLabel(10, i18n("Options"));

  table->setColumnWidth(8, 50);
  
  hLayout->insertStretch(-1,5);

  setInitialSize(QSize(800, 400));
}
MyTabDlg::~MyTabDlg(){
}
void MyTabDlg::addCol(int pos){
   table->setItem(pos, 8, new QCheckTableItem(table, ""));
   table->setItem(pos, 9, new QTableItem(table, QTableItem::OnTyping, ""));
   table->item(pos, 9)->setEnabled(false);
   table->setItem(pos, 10, new QComboTableItem(table,  0, true));
}
void MyTabDlg::valueChanged(int row, int col){
  QComboTableItem *typeBox = (QComboTableItem*)table->item(row,col);
  QString type = typeBox->currentText();

  table->item(row, 9)->setEnabled(sqlTypes.sqlTypeMap[type].selfDef);
  table->setText(row, 9, "");
  ((QComboTableItem*)table->item(row, 10))->setStringList(sqlTypes.opt1Map[type]);
  
}
void MyTabDlg::ok(SqlTable & sqlTable){
  sqlTable.mapList["Index"] = getAttrList(8, "Index");
  sqlTable.mapList["Values"] = getAttrList(9);
  sqlTable.mapList["Options"] = getAttrList(10);
}
