/***************************************************************************
                          newcondlg.cpp  -  description
                             -------------------
    begin                : Die Mr 25 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <klocale.h>
#include <kmessagebox.h>
#include "clqueue.h"
#include "newcondlg.h"


NewConDlg::NewConDlg(QWidget * parent, const QString & caption, KSqlShellDoc *document)
                      : KDialogBase(parent, "newcondlg", true, caption, Ok | Try | Cancel, Ok, true)
{
  setButtonText(Try, i18n("test"));
  doc = document;
    
  page = new QWidget(this);
  setMainWidget(page);
  
  layout = new QVBoxLayout(page, 0, spacingHint());
  
  dbTypeSelect  = new QHButtonGroup(i18n("Database Type"),page);
  mysql = new QRadioButton(i18n("MySql"), dbTypeSelect);
  pgsql = new QRadioButton(i18n("PgSql"), dbTypeSelect);
  
  lHost = new QLabel(i18n("Host:"), page);
  lPort = new QLabel(i18n("Port:"), page);
  lUser = new QLabel(i18n("User:"), page);
  lPw = new QLabel(i18n("Password:"), page);
  lDefDb = new QLabel(i18n("Default Database:"), page);
  
  host = new QLineEdit(page);
  port = new QLineEdit(page);
  user =  new QLineEdit(page);
  pw = new QLineEdit(page);
  defDb = new QLineEdit(page);

  //connect(dbTypeSelect, SIGNAL(released(int)), this, SLOT(slotSetPort(int)));
  
  
  pw->setEchoMode(QLineEdit::Password);

              
  layout->addWidget(dbTypeSelect);
  
  layout->addWidget(lHost);
  layout->addWidget(host);
  
  layout->addWidget(lPort);
  layout->addWidget(port);   
        
  layout->addWidget(lUser);
  layout->addWidget(user);

  layout->addWidget(lPw);
  layout->addWidget(pw);

  layout->addWidget(lDefDb);
  layout->addWidget(defDb);

  layout->addSpacing(24);
        
}
NewConDlg::~NewConDlg(){
}

void NewConDlg::slotSetPort(int id){
 QString sPort, sUser, sDb;
  if(id == 0){
    sPort = "";
    sUser = "root";
    sDb = "mysql";
  }else if (id == 1){
    sPort = "5432";
    sUser = "postgres";
    sDb = "";
  }
  
  host->validateAndSet("localhost", 0, 0, 0);
  port->validateAndSet(sPort, 0, 0, 0);
  user->validateAndSet(sUser, 0, 0, 0);
  defDb->validateAndSet(sDb, 0, 0, 0);
}
ClQueue::DbType NewConDlg::getDbType(){
  if(mysql->isChecked())
    return ClQueue::MYSQL;
  else 
    return ClQueue::PGSQL;
}

bool NewConDlg::checkData(){
  if(!mysql->isChecked() && !pgsql->isChecked()){
    KMessageBox::sorry(this, i18n("Database type is required"));
    return false;
  }
  if(host->text().isEmpty()){
    KMessageBox::sorry(this, i18n("Host is required"));
    return false;
  }
  /*
  if(port->text().isEmpty()){
    KMessageBox::sorry(this, i18n("Port is required"));
    return false;
  }
  */
  if(user->text().isEmpty()){
    KMessageBox::sorry(this, i18n("User is required"));
    return false;
  }
  if(defDb->text().isEmpty()){
    KMessageBox::sorry(this, i18n("Default Database is required"));
    return false;
  }
  return true;
}
void NewConDlg::slotOk(){
  if(checkData() && doc->addConnect(getDbType(), host->text(), port->text().toInt(), user->text(), pw->text(), defDb->text()))
    delayedDestruct();
}

void NewConDlg::slotTry(){
  if(!checkData())
    ;
  else if(doc->testConnect(getDbType(), host->text(), port->text().toInt(), user->text(), pw->text(), defDb->text()))
    KMessageBox::information(this, i18n("Connection Ok"));
  else
    KMessageBox::error(this, doc->getError()); 
   
}
