/***************************************************************************
                          newcondlg.h  -  description
                             -------------------
    begin                : Die Mr 25 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef NEWCONDLG_H
#define NEWCONDLG_H

#include "ksqlshelldoc.h"

#include <kdialogbase.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qhbuttongroup.h>
#include <qradiobutton.h>


/**
  *@author Olaf Gawenda
  */

class NewConDlg : public KDialogBase  {
    Q_OBJECT
public: 
	NewConDlg(QWidget * parent, const QString & caption, KSqlShellDoc *document);
	~NewConDlg();
private:

    bool checkData();
    ClQueue::DbType getDbType();
          
    QWidget *page;
    QVBoxLayout * layout;

    QHButtonGroup * dbTypeSelect;                                                                          
    QRadioButton * mysql;
    QRadioButton * pgsql;

    QLabel * lHost;
    QLabel * lPort;
    QLabel * lUser;
    QLabel * lPw;
    QLabel * lDefDb;
    
    QLineEdit * host;
    QLineEdit * port;
    QLineEdit * user;
    QLineEdit * pw;
    QLineEdit * defDb;

    KSqlShellDoc *doc;
    
private slots:
    void slotSetPort(int id);
    void slotOk();
    void slotTry();
};

#endif
