/***************************************************************************
                          newdbdlg.cpp  -  description
                             -------------------
    begin                : Mon Mr 31 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <klocale.h>
#include <kmessagebox.h>
#include "newdbdlg.h"

NewDbDlg::NewDbDlg(QWidget * parent, const QString & caption, KSqlShellDoc *document, const QString & conStr)
                            : KDialogBase(parent, "newdbdlg", true, caption, Ok | Cancel, Ok, true)
{
  doc = document;
  con = conStr;
  
  page = new QWidget(this);
  setMainWidget(page);

  layout = new QVBoxLayout(page, 0, spacingHint());

  label = new QLabel(i18n("Database Name:"), page);
  dbName = new QLineEdit(page);

  layout->addWidget(label);
  layout->addWidget(dbName);

  
}
NewDbDlg::~NewDbDlg(){
}
void NewDbDlg::slotOk(){
  if(dbName->text().isEmpty())
    KMessageBox::sorry(this, i18n("Database Name is required"));
  else if(!doc->addDb(con, dbName->text()))
    KMessageBox::error(this, doc->getError());
  else 
    delayedDestruct();
}
