/***************************************************************************
                          pgnewdbdlg.cpp  -  description
                             -------------------
    begin                : Mon Apr 7 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <qcombobox.h>
#include <qstrlist.h>
#include <kmessagebox.h>
#include <klocale.h>
#include "pgnewdbdlg.h"
#include <qlabel.h>

PgNewDbDlg::PgNewDbDlg(QWidget * parent, const QString & caption, KSqlShellDoc *document, const QString & conStr)
                                            : NewDbDlg(parent, caption, document, conStr)
{
  cBox = new QComboBox(page);
  label = new QLabel(i18n("template:"), page);
  layout->addWidget(label);
  layout->addWidget(cBox);

  QStrList list;
  list.append("");
  if(doc->clQueueMap[conStr]->getTemplates(&list))
    cBox->insertStrList(&list);
  else       
    KMessageBox::error(this, i18n("Can't get temlates"));
}
PgNewDbDlg::~PgNewDbDlg(){
}
void PgNewDbDlg::slotOk(){

  if(dbName->text().isEmpty())
    KMessageBox::sorry(this, i18n("Database Name is required"));
  else if(!doc->addDb(con, dbName->text(), cBox->currentText()))
    KMessageBox::error(this, doc->getError());
  else
    delayedDestruct();
}
