/***************************************************************************
                          pgtabdlg.cpp  -  description
                             -------------------
    begin                : Mon Apr 7 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <klocale.h>
#include "pgtabdlg.h"
#include <qstringlist.h>
#include <qsize.h>

PgTabDlg::PgTabDlg(QWidget *parent, const QString & caption, KSqlShellDoc * document, const QString & conStr, const QString & database)
                                : TabDlg(parent, caption, document, conStr, database)
{

  vGroupBox1 = new QVGroupBox(i18n("Inherits: "), page);
    
  inheritsBox = new QListBox(vGroupBox1);

  vGroupBox1->setMaximumHeight(100);
  inheritsBox->setColumnMode(10);
  inheritsBox->setSelectionMode(QListBox::Multi);

  vGroupBox3 = new QVGroupBox(i18n("OIDS"),page);
  withOIds = new QRadioButton(i18n("with OIDS"), vGroupBox3);
  
  vGroupBox2 = new QVGroupBox(i18n("Check: "), page);
  check = new QLineEdit(vGroupBox2);
  
  hLayout->insertStretch(-1, 1);
  
  hLayout->addWidget(vGroupBox1);
  
  hLayout->insertStretch(-1,1);

  hLayout->addWidget(vGroupBox3);

  hLayout->insertStretch(-1, 1),

  hLayout->addWidget(vGroupBox2);

  hLayout->insertStretch(-1, 1);

  inheritsBox->insertStringList(doc->refMap->getTables(con, db));
  

  setInitialSize(QSize(725, 420));
}
PgTabDlg::~PgTabDlg(){
}

void PgTabDlg::addCol(int pos){
}
void PgTabDlg::valueChanged(int row, int col){
}
void PgTabDlg::ok(SqlTable & sqlTable){
  sqlTable.setCheck(check->text());
  sqlTable.setOid(withOIds->isChecked());
  sqlTable.setWoOid(!withOIds->isChecked());
  
  QStringList list;
  for(int i = 0; i < (int)inheritsBox->count(); i++)
    if(inheritsBox->isSelected(i))
      sqlTable.inheritsList.append(inheritsBox->text(i));
}
