/***************************************************************************
                          queryinput.cpp  -  description
                             -------------------
    begin                : Mit Mai 7 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <klocale.h>
#include "queryinput.h"
#include "queryinputdlg.h"

QueryInput::QueryInput(){
  conStr = "";
  dbStr = "";
  table = "";
  query = "";
  refreshQuery = "";
  realQuery = "";
  orderBy = "";
  resultLabel = "";
  queryName = "";
  queryText = "";
  limitStr = "";
  type = No;
  showTypes = false;
  checkInput = true;
  refresh = false;
  isShowQuery = true;
      
  offset = 0;
  count = 0;
}
QueryInput::~QueryInput(){
}

bool QueryInput::loadInput(){
  char * pQ  = (char *)query.latin1();
  char * ref = "<input ";
  char * ref2 = "</input>";
  char * pRef = ref;
  char * pRef2 = ref2;
  bool t = false;
  bool tt = false;
  bool tag = false;
  bool isType = false;
  int i = 0;
  int begin = -1;

  QString input = "";
  QString realInput = "";
  QString type = "";
  QString realType = "";
  QString defVal = "";

  while(*pQ){

    if(*(pQ - 1) != '\\' || *(pQ - 2) == '\\'){
      if(*pQ == '\'')
        t = !t;
      if(*pQ == '\"')
        tt = !tt;
    }

    if(!tag){
      
      if(!(t || tt) && *pQ == *pRef)
        pRef ++;
      else if(!*pRef){
        if(begin == - 1)
          begin = i - 8;
        if(tt && *pQ != '\"' && !isType)
          input += *pQ;
        else if(tt && *pQ != '\"')
          type += *pQ;
        else if(!tt){
          isType = true;
          if(*pQ == '>'){ 
            realInput = input.stripWhiteSpace();
            realType = type.stripWhiteSpace();
            input = "";
            type = "";
            pRef = ref;
            isType = false;
            tag = true;
          }
        }
               
      }else
        pRef = ref;

    }else{
      defVal += *pQ;

      if(t || tt){
        pQ++; i++;
        continue;
      }

      if(*pQ == *pRef2 && *pQ != '>')
        pRef2 ++;
      else if(*pQ == '>'){
        defVal.remove(defVal.length() - 8, 10);
        Tag tTag;
        tTag.input = realInput;
        tTag.type = realType;
        tTag.value = defVal;
        tTag.begin = begin;
        tTag.end = i;
        inList.append(tTag);
        begin = -1;
        realInput = "";
        realType = "";
        defVal = "";
        pRef2 = ref2;
        tag = false;

        if(!tTag.type.isEmpty())
          showTypes = true;
        
      }else
        pRef2 = ref2;
      }

    pQ++;
    i++;
  }
  return true;
}
bool QueryInput::substInput(){
  //qDebug(">%s<", query.latin1());
  int index = 0;
  realQuery = "";
  QValueList<Tag>::Iterator it = inList.begin();
  if(type == Select){
    realQuery = query.mid(0, (*it).begin);
    QStringList selVals;
    //qDebug(realQuery.latin1());
    for(;it != inList.end(); ++it){
      if(!(*it).value.isEmpty()){
        selVals.append((*it).input + " " + (*it).value + " ");
      }
    }
    if(!selVals.isEmpty()){
      realQuery += " where \n\t" + selVals.join("\n\tand ");
    }
  }else if(type == Insert){
    realQuery = query.mid(0, (*it).begin);
    QStringList fields;
    QStringList vals;
    for(;it != inList.end(); ++it){
      if(!(*it).value.isEmpty()){
        fields.append((*it).input);
        vals.append((*it).value);
      }
    }
    if(vals.isEmpty()){
      realQuery += " values ()";
    }else{
      realQuery += " (\n\t" + fields.join(",\n\t") + "\n) values (\n\t" + vals.join(",\n\t") + "\n)";
    }
  }else{
    for(;it != inList.end();++it){
      //qDebug("%d, %d, %s, %s", (*it).begin, (*it).end, query.mid(index,(*it).begin - index).latin1(), (*it).value.latin1());
      realQuery += query.mid(index, (*it).begin - index + 1) + " " + (*it).value + " ";

      index = (*it).end + 1;
    }

    realQuery += query.mid(index , query.length() - index);

  }
  //qDebug(realQuery.latin1());
    
  return true;
}
bool QueryInput::startQuery(){
 
  if(!checkInput)
    return true;
  
  if(inList.isEmpty() && !loadInput())
    return false;

  
  if(!inList.isEmpty() || !queryName.isEmpty()){

    QString header = getConStr() + "  " + i18n("Database") + ":  '" + getDbStr() + "'   "+ i18n("Query") + ":   '" + getQueryName() + "'";
    QString showQuery = query;
    if(!isShowQuery)
      showQuery = "";
    bool run;
    QueryInputDlg qiDlg(&run, &inList, showTypes, queryName, queryText, showQuery, header, 0, i18n("query input"));
    qiDlg.exec();
    
    if(!run)
      return false;
    
    if(!substInput())
      return false;
      
     
  }else
    realQuery = query;

  return true;
}
QStringList QueryInput::split(const QString & q){
  char * pQ = (char *)q.latin1();
  bool t = true;
  bool tt = true;

  
  QStringList list;
  QString stmt = "";
  
  while(*pQ){
    
    if(*(pQ - 1) != '\\' || *(pQ - 2) == '\\'){
      if(*pQ == '\'')
        t = !t;
      if(*pQ == '\"')
        tt = !tt;
    }
    
    if(*pQ == ';' && t && tt){
      list.append(stmt);
      stmt = "";
    }else
      stmt += *pQ;
    
    pQ++;
  }

  if(!stmt.isEmpty())
    list.append(stmt);
  
  return list;
}

QStringList QueryInput::makeStmts(){
  QStringList list;
  QString newQueryString = realQuery;
  QString orderByStr = "";

  //qDebug("query: %s , realQuery: %s, refreshQuery: %s", query.latin1(), realQuery.latin1(), refreshQuery.latin1());
  
  if(!orderBy.isEmpty())
    orderByStr = " ORDER BY " + orderBy + " ";

  newQueryString += orderByStr + limitStr;
      
  if(refresh){

    if(type == Select)
      list = split(refreshQuery + orderByStr + limitStr);
    else
      list = split(refreshQuery);
    
  }else if(type == Select){
      
    list.append(newQueryString);
     
  }else if(type == Free || type == Insert){
    
    list = split(realQuery);
    
  }
  
  return list;
}
