/***************************************************************************
                          queryinput.h  -  description
                             -------------------
    begin                : Mit Mai 7 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QUERYINPUT_H
#define QUERYINPUT_H

#include <qvaluelist.h>
#include <qstringlist.h>
#include <qstring.h>
/**
  *@author Olaf Gawenda
  */

class QueryInput {
public:
   enum Type {No, Insert, Select, Free};
  QueryInput();
  ~QueryInput();
  
  
  bool startQuery();
  QStringList makeStmts();

  void setConStr(const QString & con) { conStr = con; };
  QString getConStr() {return conStr; };

  void setDbStr(const QString & db) { dbStr = db; };
  QString getDbStr() {return dbStr; };

  void setTabStr(const QString & tab) { table = tab; };
  QString getTabStr() {return table; };
  
  void setQueryName(const QString & qName) { queryName = qName; };
  QString getQueryName() {return queryName; };

  void setQueryText(const QString & qText) { queryText = qText; };
  QString getQueryText() {return queryText; };
  
  void setOrderBy(const QString & ob) { orderBy = ob; };
  QString getOrderBy() {return orderBy; };

  void setQuery( const QString & q) { query = q; };
  QString getQuery() { return query; };
  QString getRealQuery() { return realQuery; };

  void setType(Type t) {type = t;};
  Type getType() { return type; };

  void setResultLabel( const QString & resLabel) { resultLabel = resLabel; };
  QString getResultLabel(){ return resultLabel;};
  void setLimit(int o, int c) { offset = o; count = c; };
  int getOffset() {return offset; };
  int getCount() { return count; };
  
  void setLimitStr(const QString & l) { limitStr = l; };
  
  QStringList split(const QString &q);

  void setCheckInput(bool check) { checkInput = check; };

  void setRefresh(bool ref) { refresh = ref; };
  bool isRefresh() {return refresh; };

  void setRefreshQuery(const QString & rQ){ refreshQuery = rQ;};
  QString getRefreshQuery(){return refreshQuery;};

  void clearInput(){ inList.clear();};
  bool isInput(){return !inList.empty();};

  void setShowQuery(bool sq){isShowQuery = sq;};
  
  typedef struct {
    int begin;
    int end;
    QString input;
    QString type;
    QString value;
  } Tag;
  
private:

  bool loadInput();
  bool substInput();
  
  QString conStr;
  QString dbStr;
  QString table;
  QString query;
  QString refreshQuery;
  QString realQuery;
  QString orderBy;
  QString resultLabel;
  QString limitStr;
  QString queryName;
  QString queryText;
  
  QValueList <Tag> inList;
  bool showTypes;
  bool checkInput;
  bool refresh;
  bool isShowQuery;
  int offset, count;
  Type type;
};

#endif
