/***************************************************************************
                          queryinputdlg.cpp  -  description
                             -------------------
    begin                : Don Jun 5 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <klocale.h>
#include "queryinputdlg.h"

QueryInputDlg::QueryInputDlg(bool * run, QValueList<QueryInput::Tag> *inputList, bool showTypes, const QString &qName, const QString & qText, const QString & query, const QString & header, QWidget *parent, const char *name) : KDialogBase(parent,name, true, qName, Ok | Cancel, Ok, true) {
  inList = inputList;
  types = showTypes;
  runQuery = run;
  *runQuery = false;
  page = new QWidget(this);
  setMainWidget(page);

  layout = new QVBoxLayout(page, 0, spacingHint());

  hLabel = new QLabel(page);
  hLabel->setText(header);
  layout->addWidget(hLabel);
  
  hLayout = new QHBoxLayout(layout, 0);
  vLayout = new QVBoxLayout(hLayout, 0);

  if(!qText.isEmpty()){
    vGroupBox = new QVGroupBox(i18n("Query description: "), page);
    queryDiscribtion = new QTextEdit(vGroupBox);
    queryDiscribtion->setMinimumWidth(400);
    queryDiscribtion->setReadOnly(true);
    queryDiscribtion->setText(qText);
    vLayout->addWidget(vGroupBox);
  }
  if(!query.isEmpty()){
    vGroupBox2 = new QVGroupBox(i18n("query: "), page);
    queryDisplay = new QTextEdit(vGroupBox2);
    queryDisplay->setMinimumWidth(400);
    queryDisplay->setReadOnly(true);
    queryDisplay->setText(query);
    vLayout->addWidget(vGroupBox2);
  }
  
  if(!inList->isEmpty()){
    vGroupBox3 = new QVGroupBox(i18n("input: "), page);
    table = new Table(0, types ? 3 : 2, vGroupBox3);
    table->horizontalHeader()->setLabel(0, i18n("name"));
    table->horizontalHeader()->setLabel(types ? 2 : 1, i18n("value"));
    table->setMinimumWidth(300);
    table->setMinimumHeight(300);
    table->setColumnReadOnly(0, true);
    
    if(types){
      table->horizontalHeader()->setLabel(1, i18n("type"));
      table->setColumnReadOnly(1,true);
    }
    hLayout->addWidget(vGroupBox3);

    int i = 0;
    for(QValueList<QueryInput::Tag>::Iterator it = inList->begin(); it != inList->end(); ++it, i++){
      QString tag = (*it).input + (*it).type;
      
      if(!tagMap.contains(tag)){
        table->insertRows(i);   
        table->setText(i, 0, (*it).input);
        if(types){
          table->setText(i, 1, (*it).type);                
          table->setText(i, 2, (*it).value);
        }else
          table->setText(i, 1, (*it).value);
      }

      tagMap[tag].append(i);
      
    }
  }
}
QueryInputDlg::~QueryInputDlg(){
}
void QueryInputDlg::slotOk(){
  
  if(!inList->isEmpty()){
    table->editEnd();
    for (int i = 0; i < table->numRows(); i++){
      QString tag = table->item(i, 0)->text();
      if(types){                                   
        tag += table->item(i, 1)->text();
      }

      for(QValueList<int>::Iterator it = tagMap[tag].begin(); it != tagMap[tag].end(); ++it){
        (*inList)[(*it)].value = table->item(i, types ? 2 : 1)->text();
      }
    }
  }
  
  
  *runQuery = true;
  delayedDestruct();
}
