/***************************************************************************
                          queryinputdlg.h  -  description
                             -------------------
    begin                : Don Jun 5 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QUERYINPUTDLG_H
#define QUERYINPUTDLG_H

#include <qwidget.h>
#include <kdialogbase.h>
#include <qvaluelist.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qtextedit.h>
#include <qvgroupbox.h>
#include "table.h"
#include <qmap.h>
#include "queryinput.h"

/**
  *@author Olaf Gawenda
  */
  
class QueryInputDlg : public KDialogBase  {
   Q_OBJECT
public: 
	QueryInputDlg(bool * run, QValueList<QueryInput::Tag> *inputList, bool showTypes, const QString &qName, const QString & qText, const QString & query, const QString & header, QWidget *parent=0, const char *name=0);
	~QueryInputDlg();
private:
   QWidget *page;
   QVBoxLayout * layout;
   QHBoxLayout * hLayout;
   QVBoxLayout * vLayout;
   QVGroupBox *vGroupBox, *vGroupBox2, *vGroupBox3;
   QLabel * hLabel;
   QTextEdit * queryDiscribtion, *queryDisplay;
   Table * table;
   QValueList<QueryInput::Tag> *inList;
   QMap<QString, QValueList<int> > tagMap;
   bool *runQuery;
   bool types;
private slots:
   void slotOk();
};

#endif
