/***************************************************************************
                          queryconfig.h  -  description
                             -------------------
    begin                : Fre Jun 13 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QUERYMAP_H
#define QUERYMAP_H

#include <qstring.h>
#include <qvaluelist.h>
#include <qstringlist.h>
#include <qdom.h>
#include <qlistview.h>
#include "queryinput.h"

/**
  *@author Olaf Gawenda
  */

class QueryMap {
public: 
	QueryMap();
	~QueryMap();
    void setFile(const QString & file){ xmlFile = file;};
    bool loadFile();
    bool saveFile();
    QStringList getConNameList();
    QStringList getDbNameList(const QString & conStr);
    QStringList getQueryNameList(const QString & conStr, const QString & dbStr);
    bool getQueryInput(QueryInput * qi);
    bool insertQueryInput(QueryInput *qi);
    bool insertCon(const QString & con);
    bool insertDb(const QString & con, const QString & db);
    bool deleteNode(const QString & con, const QString & db = "", const QString & query = "");
    bool updateQueryInput(QueryInput *oldQi, QueryInput *newQi, bool name);
    bool rename(const QString &nName, const QString & con = "", const QString & db = "", const QString & query = "");

    QString getError(){
      QString err = error;
      error = "";
      return err;
    }
private:
    QDomNode findNode(QDomNode & node, const QString & tagName, const QString & name = "");
    QStringList getNameList(QDomNode & node,  const QString & tagName);
    bool insertQueryInput(QDomNode & node, QueryInput *qi);
    void createRootNode();
    QDomDocument domDoc;
    QDomElement root;
    QString xmlFile;
    QString error;
};

#endif
