/***************************************************************************
                          renametabdlg.cpp  -  description
                             -------------------
    begin                : Mon Jul 28 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "renametabdlg.h"
#include <kmessagebox.h>
#include <klocale.h>

RenameTabDlg::RenameTabDlg(QWidget *parent, const char *name) : KDialogBase(parent,name, true, name, Ok | Cancel, Ok, true) {
  cWin = (CentralWin*)parent;
  page = new QWidget(this);
  setMainWidget(page);
  layout = new QVBoxLayout(page, 0, spacingHint());
  labelEdit = new QLineEdit(page);
  layout->addWidget(labelEdit);
  labelEdit->setText(cWin->currentLabel);
}
RenameTabDlg::~RenameTabDlg(){
}

void RenameTabDlg::slotOk(){
  QString newLabel = labelEdit->text();

  if(newLabel == ""){
    return;
  }else if(newLabel == cWin->currentLabel){
    delayedDestruct();
  }else{
    if(cWin->labelMap.contains(newLabel)){
      QString msg = "'" + newLabel + "' " + i18n("exists");
      KMessageBox::sorry(this, msg);
      return;
    }else{
      cWin->labelMap[newLabel] = cWin->labelMap[cWin->currentLabel];
      cWin->labelMap.remove(cWin->currentLabel);
      cWin->labelMap[newLabel]->setLabel(newLabel);
      cWin->setTabLabel(cWin->labelMap[newLabel], newLabel);
    }
  }
  delayedDestruct();
}