/***************************************************************************
                          savequerydlg.cpp  -  description
                             -------------------
    begin                : Die Mai 27 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <klocale.h>
#include <kmessagebox.h>
#include "savequerydlg.h"

SaveQueryDlg::SaveQueryDlg(QWidget *parent, const char *name, KSqlShellDoc *document, QueryInput *qi) : KDialogBase(parent,name, true, "", Ok | Cancel, Ok, true) {
  doc = document;
  queryInput = qi;
  
  page = new QWidget(this);
  setMainWidget(page);

  layout = new QHBoxLayout(page, 0, spacingHint());
  vLayout = new QVBoxLayout(layout, 0);

  label = new QLabel(page);
  label->setText(qi->getConStr() + "\n" + i18n("Database") + ": " + qi->getDbStr());
  vLayout->addWidget(label);
  vLayout->addSpacing(10);
  
  vGroupBox = new QVGroupBox(i18n("Save query as: "), page);
  queryName = new QLineEdit(vGroupBox);

  vGroupBox2 = new QVGroupBox(i18n("Query description: "), page);
  queryText = new QTextEdit(vGroupBox2);
  queryText->setMinimumWidth(300);

  vLayout->addWidget(vGroupBox);
  vLayout->addWidget(vGroupBox2);

  vGroupBox3 = new QVGroupBox(i18n("Query: "), page);
  queryDisp = new QTextEdit(vGroupBox3);
  queryDisp->setMinimumWidth(400);
  queryDisp->setMinimumHeight(300);
  queryDisp->setText(queryInput->getQuery());

  layout->addWidget(vGroupBox3);

}
SaveQueryDlg::~SaveQueryDlg(){
}
void SaveQueryDlg::slotOk(){
  
  if(queryName->text().isEmpty())
    KMessageBox::sorry(this, i18n("Query label is required"));
  else{
    queryInput->setQueryName(queryName->text());
    queryInput->setQueryText(queryText->text());
    queryInput->setQuery(queryDisp->text());
    
    if(!doc->queryMap.insertQueryInput(queryInput)){
      KMessageBox::error(this, doc->queryMap.getError());
      return;
    }
                                                                             
    delayedDestruct();
  }
}
