/***************************************************************************
                          selectwidget.cpp  -  description
                             -------------------
    begin                : Mon Mai 5 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <qlabel.h>
#include <klocale.h>
#include <qiconset.h>
#include <klocale.h>
#include <qtooltip.h>
#include "selectwidget.h"


SelectWidget::SelectWidget(const QString & orderBy, int rowMin, int rowMax, QStringList *list, QWidget *parent, const char *name ) : QWidget(parent,name) {
  nextResPix =  iLoader.loadIcon("nextrows", KIcon::MainToolbar);
  layout = new QHBoxLayout(this);
  layout->addWidget(new QLabel(i18n("order by: "), this));
  comboBox = new QComboBox(true, this);
  layout->addWidget(comboBox);
  layout->addSpacing(7);
  layout->addWidget(new QLabel(i18n("next rows: "), this));
  minRow = new QSpinBox(this);
  maxRow = new QSpinBox(this);
  minRow->setMaxValue(2000000000);
  maxRow->setMaxValue(2000000000);
  minRow->setValue(rowMin);
  maxRow->setValue(rowMax);
  layout->addWidget(minRow);
  layout->addWidget(new QLabel(" - ", this));
  layout->addWidget(maxRow);
  layout->addSpacing(5);
  nextButton = new QPushButton(QIconSet(nextResPix),"", this);
  layout->addWidget(nextButton);
  
  comboBox->insertStringList(*list);
  comboBox->setCurrentText(orderBy);
  connect(nextButton, SIGNAL(clicked()), this, SLOT(slotNextRows()));
  QToolTip::add(nextButton, i18n("next rows"));
}
SelectWidget::~SelectWidget(){
}
void SelectWidget::slotNextRows(){
  int offset = 0;
  if(minRow->value() > 0)
    offset = minRow->value() - 1;
  emit signalNextRows(offset ,maxRow->value() - minRow->value() + 1,comboBox->currentText());
}
