/***************************************************************************
                          selectwidget.h  -  description
                             -------------------
    begin                : Mon Mai 5 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SELECTWIDGET_H
#define SELECTWIDGET_H

#include <qwidget.h>
#include <qlayout.h>
#include <qstringlist.h>
#include <qspinbox.h>
#include <qcombobox.h>
#include <qpushbutton.h>
#include <qpixmap.h>
#include <kiconloader.h>
/**
  *@author Olaf Gawenda
  */

class SelectWidget : public QWidget  {
   Q_OBJECT
public: 
	SelectWidget(const QString & orderBy, int rowMin, int rowMax, QStringList *list, QWidget *parent=0, const char *name=0);
	~SelectWidget();
private:
    QHBoxLayout *layout;
    QSpinBox *minRow, *maxRow;
    QComboBox *comboBox;
    QPushButton *nextButton;
    KIconLoader iLoader;
    QPixmap nextResPix;
signals:
    void signalNextRows(int offset, int count, const QString & orderBy);
private slots:
    void slotNextRows();
};

#endif
