/***************************************************************************
                          setupdlg.cpp  -  description
                             -------------------
    begin                : Don Jun 12 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "setupdlg.h"
#include <klocale.h>
#include <qfiledialog.h>
#include <kmessagebox.h>

SetupDlg::SetupDlg(KSqlShellDoc *document, QWidget *parent, const char *name ) : KDialogBase(parent,name, true, name, Ok | Cancel, Ok, true) {
  doc = document;
  page = new QWidget(this);
  setMainWidget(page);
  vLayout = new QVBoxLayout(page);

  doc->getConfig()->setGroup("General Options");
  
  vGroupBox = new QVGroupBox(i18n("tree sync time (sec)"),page);
  refresh = new QSpinBox(vGroupBox);

  vGroupBox2 = new QVGroupBox(i18n("max row num"),page);
  maxRows = new QSpinBox(vGroupBox2);
  
  
  refresh->setMinValue(1);
  refresh->setMaxValue(360000);
  refresh->setValue(doc->getSyncNaviListTime());
  
  maxRows->setMaxValue(10000);
  maxRows->setValue(doc->getConfig()->readNumEntry("maxRows"));
  
                               
  vGroupBox->setMaximumWidth(250);
  vGroupBox2->setMaximumWidth(250);
  vLayout->addWidget(vGroupBox);

  vLayout->addSpacing(20);

  vLayout->addWidget(vGroupBox2);
  vLayout->addSpacing(20);
  
  hGroupBox = new QHGroupBox(i18n("query file"), page);
  file = new QLineEdit(hGroupBox);
  file->setMinimumWidth(250);
  file->setText(doc->getConfig()->readPathEntry("QueryFile"));
  search = new QPushButton(i18n("search"), hGroupBox);
  vLayout->addWidget(hGroupBox);

  vLayout->addSpacing(20);
  
  connect(search, SIGNAL(clicked()), this, SLOT(slotSearchFile()));
}
SetupDlg::~SetupDlg(){
}
void SetupDlg::slotSearchFile(){
  doc->getConfig()->setGroup("General Options");
  file->setText(QFileDialog::getSaveFileName(doc->getConfig()->readPathEntry("QueryFile"), "*.xml"));
}
void SetupDlg::slotOk(){
  doc->getConfig()->setGroup("General Options");
  int ref = refresh->value();
  if(ref < 1)
    ref = 1;
  doc->getConfig()->writeEntry("Refresh", ref);
  doc->getConfig()->writeEntry("maxRows", maxRows->value());
  doc->getConfig()->writePathEntry("QueryFile", file->text());
  doc->setSyncNaviListTime(ref);
  doc->queryMap.setFile(doc->getConfig()->readPathEntry("QueryFile"));
   
  if(!doc->queryMap.loadFile())
    KMessageBox::sorry(this, doc->queryMap.getError());
  else
    delayedDestruct();
}