/***************************************************************************
                          shell.h  -  description
                             -------------------
    begin                : Mit Mr 5 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SHELL_H
#define SHELL_H

#include <qwidget.h>
#include <qlayout.h>
#include <qtextedit.h>
#include "ksqlshelldoc.h"
#include "shelldatas.h"

/**
  *@author Olaf Gawenda
  */

class Shell : public QTextEdit  {
   Q_OBJECT
public: 
	Shell(KSqlShellDoc *document, QWidget *parent=0, const char *name=0);
	~Shell();
    QString getCurrentConStr();
    QString getCurrentDbStr();
    QString getCurrentQuery();

    void getCurrentQueryInput(QueryInput *qi);
    
private:
    bool sendQuery(const QString & query);
    bool runInput(const QString & input);
    QString getError();
    QString error;
    KSqlShellDoc *doc;
    ShellDatas shellDatas;
    ShellDatas::ShellData *shellData;
    void history(bool back = false);
protected:
    bool eventFilter(QObject *o, QEvent *e);
public slots:
    void slotChangeDb(const QString & conStr, const QString &dbStr);
private slots:
    void slotReturn();
    void slotCursorPositionChanged(int para, int pos);
};

#endif
