/***************************************************************************
                          shelldata.h  -  description
                             -------------------
    begin                : Mon Mai 19 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SHELLDATA_H
#define SHELLDATA_H

#include <qmap.h>
#include <qstring.h>
#include <qptrlist.h>
/**
  *@author Olaf Gawenda
  */

class ShellDatas {
public:
  
    typedef struct {
      QString con;
      QString db;
      QString prompt;
      uint promptLen;
      QString text;
      int lastCmdPara;
      int para;
      int pos;
      QPtrList<QString> history;
      uint histIndex;
    } ShellData;
    
     ShellDatas();
  
	~ShellDatas();
    
    ShellData * getShellData(const QString & conStr, const QString & dbStr);
    void removeData(const QString & conStr, const QString &dbStr = "");
    void newData(const QString & conStr, const QString & dbStr);
    bool contains(const QString & conStr, const QString & dbStr);
    void test();
    
private:
    QMap<QString, QMap<QString, ShellData> > shellDataMap;
  
};

#endif
