/***************************************************************************
                          sqlclient.cpp  -  description
                             -------------------
    begin                : Mon Mr 10 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "sqlclient.h"

SqlTypes::SqlTypes(){
}
SqlTypes::SqlTypes(SqlType *sqlType, int len){
  for (int i = 0; i < len; i++){
    typeList.append(sqlType[i].name);
    QStringList opt0List, opt1List;
    
    opt0List.append(sqlType[i].opt00);
    if(!sqlType[i].opt01.isEmpty())
      opt0List.append(sqlType[i].opt01);
    if(!sqlType[i].opt02.isEmpty())
      opt0List.append(sqlType[i].opt02);
    if(!sqlType[i].opt03.isEmpty())
      opt0List.append(sqlType[i].opt03);

    opt1List.append(sqlType[i].opt10);
    if(!sqlType[i].opt11.isEmpty())
      opt1List.append(sqlType[i].opt11);
    if(!sqlType[i].opt12.isEmpty())
      opt1List.append(sqlType[i].opt12);
    if(!sqlType[i].opt13.isEmpty())
      opt1List.append(sqlType[i].opt13); 
      
    opt0Map[sqlType[i].name] = opt0List;
    opt1Map[sqlType[i].name] = opt1List;
    sqlTypeMap[sqlType[i].name] = sqlType[i];
  }
}
SqlTypes::~SqlTypes(){
}

Result::Result(const QString & st){
  stmt = st;
  table = "";
  error = "";
  isRes = false;
  stmtok = false;
}
Result::~Result(){
}

SqlClient::SqlClient(const QString& dbHost, int dbPort, const QString& dbUser, const QString& dbPw, const QString& dbName){
  host = dbHost;
  user = dbUser;
  pw = dbPw;
  defDb = dbName;
  aktDb = "";
  port = dbPort;
  error = "";
  table = "";
  isRes = false;
  queryok = false;
  resultList.setAutoDelete(true);
}
SqlClient::SqlClient(){}
SqlClient::~SqlClient(){}

void SqlClient::clear(){
  aktDb = "";
  error = "";
  queryok = false;
  isRes = false;
  table = "";

  resultList.clear();
}

QString SqlClient::getCurrentDb(){
  return aktDb;
}

QString SqlClient::getError(){
  QString err = error;
  error = "";
  return err;
}

bool SqlClient::queryOk(){
  return queryok;
}

bool SqlClient::sendQuery(const QueryInput & qI){
  queryInput = qI;

  QString db = defDb;
    
  if(!queryInput.getDbStr().isEmpty())
    db = queryInput.getDbStr();

  if(!useDb(db))
    return false;

  queryInput.setLimitStr(limitClause(queryInput.getOffset(),queryInput.getCount()));
    
  QStringList stmtList = queryInput.makeStmts();
   
  return startQuery(stmtList);
}
bool SqlClient::getVersionStr(){
  return runStmt("select version()");
}
float SqlClient::getVersionNum(const QString & versionStr){
  char * vstr = (char *)versionStr.latin1();
  QString vNum = "";
  bool dot = false;
  while(*vstr){
      if(*vstr > 47 && *vstr < 58 || *vstr == '.'){
        if(*vstr != '.' || !dot){
          vNum.append(*vstr);
        }
        if(*vstr == '.' && !dot)
          dot = true;
      }
      if((*vstr <   48 || *vstr > 57) && *vstr != '.' && !vNum.isEmpty())
        break;

      vstr++;
  }
  bool ok;
  float vers = vNum.toFloat(&ok);
  if(!ok)
    return(0.0);
    
  return vers;
}