/***************************************************************************
                          sqltable.h  -  description
                             -------------------
    begin                : Die Apr 15 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SQLTABLE_H
#define SQLTABLE_H

#include <qstring.h>
#include <qstringlist.h>
#include <qmap.h>

/**
  *@author Olaf Gawenda
  */

class SqlTable {
public:
  enum TableAction { No, NewTable, DelTable, RenameTable, RenameField, ChangeField, AddField, DelField };
  
  SqlTable();
  ~SqlTable();
  
  QString getError();
  void setError(const QString & err){ error = err; };
  QStringList inheritsList;
  QMap<QString, QStringList> mapList;
  QStringList attrList;
  QMap<QString, QStringList>::Iterator mpI;

  void setConStr(const QString & conStr) { con = conStr; };
  QString getConStr(){ return con; };

  void setDbStr(const QString & dbStr) { db = dbStr; };
  QString getDbStr(){ return db; };

  void setTabStr(const QString & tabStr) { tab = tabStr; };
  QString getTabStr(){ return tab; };
  
  void setFieldNum(int num);
  int getFieldNum(){return fieldNum;}

  void setOid(bool isOid) { oids = isOid; };
  bool isOid(){ return oids; };

  void setWoOid(bool woOid) {woOids = woOid;};
  bool isWoOid(){return woOids;};
  
  void setPKey(bool primKey) { pKey = primKey;};
  bool isPKey() {return pKey;};

  void setTableAction(TableAction act) { action = act;};
  TableAction getTableAction() {return action;};

  int getFieldIndex(const QString & field);

  void setNewTabName(const QString & nTab) { newTab = nTab;};
  QString getNewTabName() {return newTab;};

  void setChangeField(const QString & field) { changeField = field;};
  QString getChangeField() {return changeField;};

  void setCheck(const QString & chk) { check = chk;};
  QString getCheck() {return check;};

  void setNewFieldPos(const QString & pos) { newFieldPos = pos;};
  QString getNewFieldPos() {return newFieldPos;};
    
private:
  int fieldNum;
  QString error;
  QString con;
  QString db;
  QString tab;
  QString newTab;
  QString changeField;
  QString check;
  QString newFieldPos;
  
  bool oids;
  bool woOids;
  bool pKey;

  TableAction action;
};

#endif
