/***************************************************************************
                          tabdlg.h  -  description
                             -------------------
    begin                : Mon Apr 7 2003
    copyright            : (C) 2003 by Olaf Gawenda
    email                : o.gawenda@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TABDLG_H
#define TABDLG_H

#include <kdialogbase.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qstring.h>
#include <qpoint.h>
#include <qpopupmenu.h>
#include <qmap.h>
#include <qstringlist.h>
#include <qvgroupbox.h>
#include <qtextedit.h>
#include <kmessagebox.h>
#include "sqlclient.h"
#include "ksqlshelldoc.h"
#include "sqltable.h"
#include "table.h"

/**
  *@author Olaf Gawenda
  */

class TabDlg : public KDialogBase  {

Q_OBJECT
  
public: 
	TabDlg(QWidget *parent, const QString & caption, KSqlShellDoc * document, const QString & conStr, const QString & database);
	~TabDlg();

    void startDlg();
protected:
    KSqlShellDoc * doc;

    QString con;
    QString db;

    QWidget *page;
    QVGroupBox *vGroupBox;
    QLineEdit *tableName;
    
    QVBoxLayout * layout;
    QHBoxLayout * hLayout;
    Table *table;

    QPopupMenu *menu;

    int colPos;

    SqlTypes sqlTypes;

    bool edit;

    QTextEdit *createText;
    
    void initDlg();
    QStringList getAttrList(int attr);
    QStringList getAttrList(int attr, const QString & attrStr);
    SqlTable getValues();
    virtual void addCol(int pos) = 0;
    virtual void valueChanged(int row, int col) = 0;
    virtual void ok(SqlTable & sqlTable) = 0;
protected slots:
  void slotMenu(int pos);
  void slotAddDelCol(int id);
  void slotAddCol();
  void slotDelCol();
  void slotValueChanged(int row, int col);
  void slotOk();
  void slotUser1();
};

#endif
